// FleshCloner.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <stdio.h>
#include <tchar.h>
#include <conio.h>
#include <algorithm>
#include <Windows.h>
#include <setupapi.h>
#include <cfgmgr32.h>
#include <WinIoCtl.h>

#include "RemovebleDeviceInfo.h"
#include <iostream>
#include <windows.h>
using namespace Library;

ULONGLONG GetLogicalDriveSize(HANDLE hDrive)
{
	PARTITION_INFORMATION lpOutBuffer;
	DWORD lpBytesReturned = 0;
	if(!DeviceIoControl(hDrive,          
		IOCTL_DISK_GET_PARTITION_INFO,   
		NULL,                            
		0,                               
		&lpOutBuffer,                    
		(DWORD)sizeof(lpOutBuffer),      
		&lpBytesReturned,                
		NULL))
		throw std::exception("Could not get file size");
	return lpOutBuffer.PartitionLength.QuadPart;
}

void WriteFlesh(const std::wstring& path, std::vector<unsigned char>& buffer)
{
	HANDLE hFile = ::CreateFile(path.c_str(),
		GENERIC_WRITE,
		0,
		0,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		0);

	DWORD dwBytesWritten;
	if ( ! ::WriteFile(hFile, &buffer.front(), buffer.size(), &dwBytesWritten, 0) )
	{
		throw std::exception("Could not write");
	}

	::CloseHandle(hFile);
}

void MakeDump(const wchar_t* path)
{
	RemovableDeviceInfo_vt devices = Functions::SearchRemovalDisks();// get all removable disks
	if (devices.empty())
	{
		std::cout << "Mass storage devices was not found\n";
		return;
	}

	std::cout << "Please enter device number\n";
	for (size_t i = 0; i < devices.size(); ++i)
	{
		std::cout << i << ". ";
		std::cout << devices.at(i).wsFriendlyName.c_str()<< L"\n";
	}

	int driveIndex;
	std::cin >> driveIndex;//selecting a disk
	std::vector<unsigned char> buffer;
	//creating a path
	std::wstring dumpPath(L"\\\\.\\PhysicalDrive");
	wchar_t index[MAX_PATH];
	_itow(devices.at(driveIndex).vHarddiskIndexes[0], index , MAX_PATH);
	dumpPath.append(index);
	//opening mass storage for reading
	//requires administrator privilege
	HANDLE hDump( ::CreateFile(
		dumpPath.c_str(), 
		GENERIC_READ, 
		FILE_SHARE_READ | FILE_SHARE_WRITE, 
		NULL, 
		OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_BACKUP_SEMANTICS, 
		NULL) );
	//opening file to save a dump
	//requires administrator privilege
	HANDLE hFile = ::CreateFile(path,
		GENERIC_WRITE,
		0,
		0,
		CREATE_NEW,
		FILE_ATTRIBUTE_NORMAL,
		0);

	DiskGeometry diskGeometry = devices.at(driveIndex).diskGeometry;
	DWORD dwRead = 0;
	DWORD dwMb = (1024*1024);
	LARGE_INTEGER liFullSize = {0,0};
	LARGE_INTEGER liTotalRead = {0,0};
	DWORD dwSize = diskGeometry.BytesPerSector * diskGeometry.SectorsPerTrack;
    //Getting a size of a removable disk
	liFullSize.QuadPart = GetLogicalDriveSize(hDump);

	dwSize = diskGeometry.BytesPerSector;
	std::vector<unsigned char> tempBuff(dwSize, 0x00);

	double dProgrVal = 0.0;
	double dProgrStep = 100.0 / (liFullSize.QuadPart) * dwSize;

	// reading from removable disk and writing to a dump file
	while ( (liFullSize.QuadPart > liTotalRead.QuadPart) && ::ReadFile(hDump, &tempBuff.at(0), dwSize, &dwRead, NULL) && dwRead )
	{
	    DWORD dwBytesWritten;

		if ( ! ::WriteFile(hFile, &tempBuff.front(), tempBuff.size(), &dwBytesWritten, 0) )
		{
			throw std::exception("Could not write");
		}

		dProgrVal += dProgrStep;
		std::cout << dProgrVal<<'\n';
		liTotalRead.QuadPart += dwRead;
	}

	::CloseHandle(hDump);
	::CloseHandle(hFile);
}

void MakeFileFromOffsets(int startOffset, int finishOffset, const wchar_t* dumpPath, const wchar_t* filePath)
{
	HANDLE hDump( ::CreateFile(
		dumpPath, 
		GENERIC_READ, 
		FILE_SHARE_READ | FILE_SHARE_WRITE, 
		NULL, 
		OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_BACKUP_SEMANTICS, 
		NULL) );

	HANDLE hFile(::CreateFile(
		filePath, 
		GENERIC_READ, 
		FILE_SHARE_READ | FILE_SHARE_WRITE, 
		NULL, 
		CREATE_NEW, 
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_BACKUP_SEMANTICS, 
		NULL));

	::SetFilePointer(hDump, startOffset, NULL, FILE_BEGIN);

	std::vector<unsigned char> tempBuff(0x200, 0x00);
	std::vector<unsigned char> buffer;
	int readed = 0;
	DWORD dwSize;
	DWORD dwRead;

	while ( (finishOffset - startOffset > readed) && ::ReadFile(hFile, &tempBuff.at(0), dwSize, &dwRead, NULL) && dwRead )
	{
		tempBuff.resize(dwRead);
		buffer.insert(buffer.end(), tempBuff.begin(), tempBuff.end());
		tempBuff.resize(dwSize);

		readed += dwRead;
	}

    DWORD dwBytesWritten;
	if ( ! ::WriteFile(hFile, &buffer.front(), buffer.size(), &dwBytesWritten, 0) )
	{
		throw std::exception("Could not write");
	}


	::CloseHandle(hFile);
	::CloseHandle(hDump);
}

void ClearFlesh()
{
	RemovableDeviceInfo_vt devices = Functions::SearchRemovalDisks();
	if (devices.empty())
	{
		std::cout << "Mass storage devices was not found\n";
		return;
	}

	std::cout << "Please enter device number\n";
	for (size_t i = 0; i < devices.size(); ++i)
	{
		std::cout << i << ". ";
		std::cout << devices.at(i).wsFriendlyName.c_str()<< "\n";
	}

	int driveIndex;
	std::cin >> driveIndex;

	std::wstring path(L"\\\\.\\PhysicalDrive");
	wchar_t index[MAX_PATH];
	_itow(devices[driveIndex].vHarddiskIndexes[0], index , MAX_PATH);
	path.append(index);


	HANDLE hFile = ::CreateFile(path.c_str(),
		GENERIC_WRITE,
		0,
		0,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		0);

	DiskGeometry diskGeometry = devices.at(driveIndex).diskGeometry;
	DWORD dwRead = 0;
	DWORD dwMb = (1024*1024);
	LARGE_INTEGER liFullSize = {0,0};
	LARGE_INTEGER liTotalRead = {0,0};
	DWORD dwSize = diskGeometry.BytesPerSector * diskGeometry.SectorsPerTrack;


	std::vector<unsigned char> buffer(1024);
	DWORD dwBytesWritten;
	while (::WriteFile(hFile, &buffer.front(), buffer.size(), &dwBytesWritten, 0));

	::CloseHandle(hFile);
}

int _tmain(int argc, _TCHAR* argv[])
{
	std::cout << "Please select Action\n0. Make Dump\n1. Open Dump\n2. Clear flesh\n";
	size_t actionIndex;
	std::cin >> actionIndex;

	int startOffset = 0;
	int finishOffset = 0;
	wchar_t path[MAX_PATH];
	wchar_t pathToFile[MAX_PATH];


	switch (actionIndex)
	{
	case 0: 
		std::cout << "Please enter the path where the dump must be sawed\n";
		std::wcin >> path;
		MakeDump(path);
		break;
	case 1:
		std::cout << "Please enter the path to the dump\n";
		std::wcin.getline(path, MAX_PATH);
		std::cout << "Please enter the path to a new file\n";
		std::wcin.getline(pathToFile, MAX_PATH);
		std::cout << "Please enter a start offset and finish offset\n";
		std::cin >> startOffset >> finishOffset;
		MakeFileFromOffsets(startOffset, finishOffset, path, pathToFile);
		break;
	case 2:
		ClearFlesh();
		break;
	default:
		std::cout << "Wrong number\n";
		break;
	}
	return 0;
}

